<?php

namespace Quivers\Integration\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;

class ProductSaveAfterObserver implements ObserverInterface
{    
    public function execute(EventObserver $observer)
    {
        $product = $observer->getProduct();  // you will get product object
        $taxCode = $product->getData('product_tax_category');
    	if ($product->getData('type_id') == 'configurable'){
    	$productTypeInstance = $product->getTypeInstance();
    	$usedProducts = $productTypeInstance->getUsedProducts($product);

    	foreach ($usedProducts  as $child) {
    		if ($product->getData('type_id') != 'virtual')
    		{
        	$child->setData('product_tax_category', $taxCode);
			$child->getResource()->saveAttribute($child, 'product_tax_category');
        	}
    		
    		}
    	}

    }   
}